# Put the tarball j2se-1.4.2xx-linux-i586.bin in the source directory.
# This spec file will automatically find the tar ball when you build.

%define name j2se
%define package_name j2sdk
%define tarball %(cd %{_sourcedir}; ls %{package_name}-*-linux-i586.bin | tail -n 1)
%define version %(echo %{tarball} | cut -d- -f2 | tr '_' '.')
%define major_version %(echo %{version} | sed -e 's/.0[1-9]$//')
%define patchlevel %(echo %{version} | sed -e 's/^[0-9].[0-9].[0-9]//' | tr -d .)
#if %{patchlevel}
%define dirname %{major_version}_%{patchlevel}
#else
#define dirname %{major_version}
#endif
%define release b1

%define javaroot %{_libdir}/java
%define javadir %{javaroot}
%define jredir  %{javadir}/jre
%define javawsdir %{javadir}/jre/javaws
%define javamandir %{javadir}/man
%define mimedir %{_datadir}/mime-info
%define applnkdir /etc/X11/applnk
%define manconf /etc/man.config

%define nslibdir %(type -path netscape | sed 's,bin/netscape,lib/netscape,')
%define mozlibdir %(type -path mozilla | sed 's,bin/mozilla,lib/mozilla,')
%define nspidir %(ls -d %{nslibdir}*/plugins 2> /dev/null)
%define mozpidirs %(ls -d %{mozlibdir}*/plugins 2> /dev/null | tail -n1)
%define _moz %( [ -e "%{mozpidirs}" ] && echo 1 || echo 0)
%define _nss  %( [ -e "%{nspidir}" ]   && echo 1 || echo 0)
%define _ns   %( [ %_nss -a %_moz == 0 ]   && echo 1 || echo 0)
%define mozpidir %(echo %{mozpidirs} | sed 's,[-][^/]*,,')

%define vine %(test -s /etc/vine-release && echo 1 || echo 0)
%define gcc32 %(test -f /lib/libgcc_s.so.1 && echo 1 || echo 0)

Summary: Java 2 Platform, Standard Edition
Summary(ja): Java 2 ɸ७å
Name: %{name}
Version: %{version}
Release: %{release}
URL: http://java.sun.com/j2se/1.4.2/
Copyright: Sun Java License.
Group: Development/Languages
#if %{patchlevel}
#Source0: %{package_name}-%(echo %{major_version}| tr . _)_%{patchlevel}-linux-i586.bin
#else
#Source0: %{package_name}-%(echo %{major_version}| tr . _)-linux-i586.bin
#endif
Source0: %{tarball}

NoSource: 0
Buildroot: %{_tmppath}/%{name}-%{version}-root

#Distribution: Vine Linux
#Vendor: Project Vine

%description
Sun's Java 2 Platform, Standard Edition
Requires glibc.  Supports native threads.

%package sdk
Summary: Sun's Java 2 SDK Standard Edition
Summary(ja): Java 2 ȯå
Group: Development/Languages

Autoreq: 0
Requires: %{name}-jre
Provides: j2sdk, jdk, j2sdk-odbc
Obsoletes: j2sdk, jdk, j2sdk-odbc

%description sdk
The Java 2 SDK is a development environment for building applications,
applets, and components using the Java programming language.
The Java 2 SDK includes tools useful for developing and testing programs
written in the Java programming language and running on the Java platform.These tools are designed to be used from the command line. Except for the
appletviewer, these tools do not provide a graphical user interface.

%package jre
Summary: Sun's 2 Java Runtime Environment 
Summary(ja): Java 2 ¹ԴĶ
Group: Development/Languages

Autoreq: 0
Requires: glibc
%if %gcc32
Requires: libgcc
%endif
Provides: j2re, jre, j2re-odbc
Obsoletes: j2re, jre, j2re-odbc

%description jre
Sun's Java 2 Standard Edition Runtime Environment. 
This provides complete runtime support for Java 2 applications.
The runtime environment includes the Java Plug-in product which
supports running the Java 2 environment inside web browsers.

%package javaws
Summary: Sun's 2 Java Web Start
Group: Development/Languages

Autoreq: 0
Requires: %{name}-jre

%description javaws
Java Web Start allows you to launch Java-technology-based applications
 directly from the Web.

%description -l ja javaws
Java Web Start ѤȡJava ƥΥ١Υץꥱ
Web ľܵưǤޤ

%prep -n %{package_name}%{dirname}
%__rm -rf %{buildroot}
%__rm -rf %{_builddir}/%{package_name}%{dirname}
sh %{SOURCE0}

cd %{_builddir}/%{package_name}%{dirname}
chmod +w -R *

# java web start
#unzip jre/javaws-*.zip -d Javaws && %__rm -f  *.zip
#(cd Javaws
#mv install.sh install.org
#cat install.org | sed \
#  -e 's:^.*javaPath=$:javaPath=%{buildroot}%{jredir}:' \
#  > install.sh
#chmod +x install.sh
#)

# rewrite font.properties.ja.* for Vine Linux
%if %{vine}
cd %{_builddir}/%{package_name}%{dirname}/jre/lib
%__mv font.properties.ja font.properties.ja.Redhat.org
cat font.properties.ja.Redhat.org | sed \
   -e 's/watanabe/alias/' \
   -e 's/wadalab/alias/' \
   -e 's/sony/alias/' \
   -e 's/-c-/-*-/' \
   > font.properties.ja

for i in $(ls font.properties.*Redhat*);do
	%__mv $i $i.org
done
%endif

%build

%install
cd %{_builddir}/%{package_name}%{dirname}
%__mkdir_p %{buildroot}%{javadir}
%__mkdir_p %{buildroot}%{_datadir}
%__mkdir_p %{buildroot}%{javamandir}/man1
%__mkdir_p %{buildroot}%{javamandir}/ja/man1
%__mkdir_p %{buildroot}/etc/profile.d
%__mkdir_p %{buildroot}%{nspidir}
%__mkdir_p %{buildroot}%{mozpidir}
%__mv jre/lib/locale %{buildroot}%{_datadir}/locale
%__cp -pR bin demo include lib %{buildroot}%{javadir}
%__mkdir_p %{buildroot}%{javadir}/jre
%__cp -pR jre/bin jre/lib jre/plugin %{buildroot}%{javadir}/jre

# jre documents
%__mkdir Jre
%__cp jre/[A-Z]* Jre

%__install -m 644 man/man1/*      %{buildroot}%{javamandir}/man1
%__install -m 644 man/ja_JP.eucJP/man1/*  %{buildroot}%{javamandir}/ja/man1

%__mkdir_p %{buildroot}/etc/profile.d

cat << EOF > %{buildroot}/etc/profile.d/j2re.sh
#!/bin/bash
export JAVA_HOME=%{javadir}
tmpdir="\$JAVA_HOME/jre/bin"
if [ -z "\$PATH" ] ; then
        export PATH=\$tmpdir
elif [ -z \`echo ":\${PATH}:" | grep "\${tmpdir}"\` ] ; then
        export PATH="\${tmpdir}:\${PATH}"
fi
EOF

cat << EOF > %{buildroot}/etc/profile.d/j2sdk.sh
#!/bin/bash
tmpdir="\$JAVA_HOME/bin"
if [ -z "\$PATH" ] ; then
        export PATH=\$tmpdir
elif [ -z \`echo ":\${PATH}:" | grep "\${tmpdir}"\` ] ; then
        export PATH="\${tmpdir}:\${PATH}"
fi
EOF

cat << EOF > %{buildroot}/etc/profile.d/j2re.csh
#!/bin/csh
setenv JAVA_HOME %{javadir}
#Add directories to the PATH environment variable if they aren't in it already
set tmpdir=\$JAVA_HOME/jre/bin
set test=\`echo ":\${PATH}:" | grep ":\${tmpdir}:"\`
if ( ! \${#test} ) setenv PATH \${PATH}:\${tmpdir}
EOF

cat << EOF > %{buildroot}/etc/profile.d/j2sdk.csh
#!/bin/csh
#Add directories to the PATH environment variable if they aren't in it already
set tmpdir=\$JAVA_HOME/bin
set test=\`echo ":\${PATH}:" | grep ":\${tmpdir}:"\`
if ( ! \${#test} ) setenv PATH \${PATH}:\${tmpdir}
EOF

%__chmod +x %{buildroot}/etc/profile.d/*


NS=ns610
%if %gcc32
NS=ns610-gcc32
%endif
SO=libjavaplugin_oji.so
%__ln_s %{jredir}/plugin/i386/$NS/$SO \
                     %{buildroot}%{mozpidir}/$SO
%if %_ns
    NSVER=$(netscape --version 2>&1) || NSVER=""
    if echo $NSVER | grep '^[^0-9]*4' ;then
        NS=ns4
        SO=javaplugin.so
    fi
    [ "$NSVER" != "" ] && \
    %__ln_s %{jredir}/plugin/i386/$NS/$SO \
                       %{buildroot}%{nspidir}/$SO
%endif

# java.desktop
#__install -d %{buildroot}/%{icondir}
#__install jre/plugin/desktop/*.png %{buildroot}/%{icondir}
%__install -d %{buildroot}%{applnkdir}/Internet
cat > %{buildroot}%{applnkdir}/Internet/sun_java.desktop <<EOF
[Desktop Entry]
Name=Java
Comment=Java Control Panel
Exec=%{jredir}/bin/ControlPanel
Icon=%{jredir}/plugin/desktop/sun_java.png
Terminal=false
MultipleArgs=false
Type=Application
EOF
#Categories=Application;Settings

# move some manuals batting with gcc-docs
%if %gcc32
#%__rm %{buildroot}%{_mandir}/man1/rmi* 
#%__rm %{buildroot}%{_mandir}/*/man1/rmi*
%__mv man Jre
%endif

# java web start
%__install -d -m 775 %{buildroot}/%{javawsdir}

# javaws.cfg
#
#(cd javaws
#HOME=%{buildroot}%{javawsdir} ./install.sh
#cd javaws
#chmod +w *
#mv javaws.cfg javaws.cfg.bak
#cat javaws.cfg.bak | sed 's:%{buildroot}::' > javaws.cfg
#if %{_moz}
#grep -q browserPath javaws.cfg || \
#  echo "javaws.cfg.browserPath=mozilla" >> javaws.cfg
#endif
#rm javaws.cfg.bak
#)

cat > jre/javaws/javaws.cfg << EOF
javaws.cfg.jre.0.platform=1.4
javaws.cfg.jre.0.location=http\://java.sun.com/products/autodl/j2se
javaws.cfg.jre.0.product=%{major_version}
javaws.cfg.jre.0.path=%{jredir}/bin/java
javaws.player.mode=1
javaws.player.manager=1
javaws.player.bounds=250,190,523,387
%if %{_moz}
javaws.cfg.browserPath=mozilla
%else
javaws.cfg.browserPath=netscape
%endif
EOF

# /usr/bin/javaws
%__install -d %{buildroot}%{_bindir}
cat jre/javaws/javaws | sed \
  -e 's:^APPHOME=.*$:APPHOME=%{javawsdir}:' \
  > %{buildroot}%{_bindir}/javaws
chmod +x %{buildroot}%{_bindir}/javaws

%__cp -pR jre/javaws/* %{buildroot}%{javawsdir}
#rm -fR javaws
#rm -f install.*

echo "application/x-java-jnlp-file; %{jredir}/javaws/javaws %s" > mailcap
echo "type=application/x-java-jnlp-file desc=\"Java Web Start\" exts=\"jnlp\"" > mime.types
%__install mailcap mime.types %{buildroot}%{javawsdir}

# jedrc
#__cp %{buildroot}%{javawsdir}/.jedrc jedrc
#__rm %{buildroot}%{javawsdir}/.[a-z]*

# mime-info
%__install -d %{buildroot}%{mimedir}
cat << EOF > %{buildroot}%{mimedir}/javaws.keys
application/x-java-jnlp-file:
	open=javaws %f
EOF
cat << EOF > %{buildroot}%{mimedir}/javaws.mime
application/x-java-jnlp-file
	ext: jnlp
EOF

# prepare applnk
%__install -d %{buildroot}%{applnkdir}/Internet
cat > %{buildroot}%{applnkdir}/Internet/javaws.desktop <<EOF
[Desktop Entry]
Name=JAVAWS
Comment=JAVA Web Start
Exec=javaws
Icon=%{javawsdir}/resources/splash.jpg
Terminal=false
MultipleArgs=false
Type=Application
EOF


%clean
#rm allfile alldir filelist odbclist
%__rm -rf %{buildroot}

%post jre
%if %{vine}
  %__rm -f %{javadir}/jre/lib/font.properties.*Redhat[0-9.]
%endif
# set MANPATH
if [ -f %{manconf} ] ; then
  if grep -q  %{javamandir} %{manconf} ;then
    cat %{manconf} | \
    (
    while read line ; do
	echo $line | grep -q '^MANPATH ' && break
	echo $line >> %{manconf}.rpmnew
    done
    while read line ; do
	echo $line | grep -q '^MANPATH ' || break
	echo $line >> %{manconf}.rpmnew
    done
    echo 'MANPATH %{javamandir}' >> %{manconf}.rpmnew
    while read line ; do
	echo $line >> %{manconf}.rpmnew
    done
    )
    [ -s %{manconf}.rpmnew ] && mv %{manconf} %{manconf}.rpmsave && \
    mv %{manconf}.rpmnew %{manconf}
  fi
fi
:

%postun jre
if [ $1 = 0 ]; then
  # remove MANPATH
  if [ -f %{manconf} ] ; then
      if grep '%{javamandir}' ;then
	grep -v '%{javamandir}' > %{manconf}.rpmnew
   	[ -s %{manconf}.rpmnew ] && \
	mv %{manconf} %{manconf}.rpmsave && \
	mv %{manconf}.rpmnew %{manconf}
      fi
  fi
fi

%post javaws

F=/etc/mailcap
R=%{javawsdir}/mailcap
if [ -w $F -a -f $R ] ; then
  grep -q 'x-java-jnlp-file' $F || \
  cat $R >> $F
fi

F=/etc/mime.types
R=%{javawsdir}/mime.types
if [ -w $F -a -f $R ] ; then
  grep -q 'x-java-jnlp-file' $F || \
  cat $R >> $F
fi
:

%postun javaws
if [ $1 = 0 ]; then
  F=/etc/mailcap
  if [ -w $F ] ; then
     grep -v  'x-java-jnlp-file' $F > $F.rpmnew
     [ -s $F.rpmnew ] && mv $F $F.rpmsave && mv $F.rpmnew $F  
  fi
fi
:

%files sdk
%defattr(-,root,root)
%doc %{package_name}%{dirname}/[CLR]* %{package_name}%{dirname}/demo
%{javadir}/[^dj]*
/etc/profile.d/j2sdk.*

%files jre
%defattr(-,root,root)
%doc %{package_name}%{dirname}/Jre/*
%dir %{javadir}
%{javadir}/jre
/etc/profile.d/j2re.*
%if %_ns
  %{nspidir}/*
%endif
%if %_moz
  %{mozpidir}/*
%endif
%{_datadir}/locale/*/LC_MESSAGES/*.mo
%{javamandir}/man1/*
%{javamandir}/*/man1/*
%config(missingok) %{applnkdir}/Internet/sun_java.desktop

%files javaws
%defattr(-,root,root)
%doc %{package_name}%{dirname}/jre/javaws/*{.html,.gif}
%{javawsdir}
%{_bindir}/*
%{mimedir}/*
%config(missingok) %{applnkdir}/Internet/javaws.desktop


%changelog
* Thu Mar 25 2004 Yuichiro Nakada <berry@po.yui.mine.nu>
- from http://shino.pos.to/linux/mozilla.html
- Create for Berry Linux
